unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  fpspreadsheetctrls, fpspreadsheet, fpspreadsheetgrid, fpstypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    sWorksheetGrid1: TsWorksheetGrid;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  slog, srow, scol: String;
  MyWorkbook: TsWorkbook;
  MyWorksheet: TsWorksheet;
  iWorksheet, ColMax, RowMax, iRow, iCol: Integer;

begin
  MyWorkbook := TsWorkbook.Create;
  MyWorkBook.ReadFromFile('testfps.ods', sfOpenDocument);
  sWorksheetGrid1.LoadFromSpreadsheetFile('testfps.ods', sfOpenDocument);
  Memo1.Clear;
  // all Worksheets for
  for iWorksheet := 0 to MyWorkbook.GetWorksheetCount() - 1 do begin
    MyWorksheet := MyWorkbook.GetWorksheetByIndex(iWorksheet);
    ColMax := MyWorksheet.GetLastColIndex;
    RowMax:= MyWorksheet.GetLastRowIndex;
    slog :=  Format(' worksheet ColMax=[%d], RoWMax=[%d]',[ColMax, RowMax]);
    Memo1.Append('found ' + MyWorkSheet.Name + sLog);

    // parse sheet now
    ColMax := MyWorksheet.GetLastColIndex; RowMax:= MyWorksheet.GetLastRowIndex;

    for iRow := 0 to RowMax do begin
      srow:= '';
      for iCol := 0 to ColMax do begin
        scol := MyWorksheet.ReadAsText(iRow, iCol);
        srow := srow + chr(9)+scol;
      end;
       Memo1.Append(InttoStr(iRow) + ' -> '+ srow);
    end;


  end; // for each worksheets ---------------------------------------------------
   MyWorkBook.Destroy;
end;


end.

